/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libnbd.h>

#include "nbd-c.h"

#include <caml/alloc.h>
#include <caml/callback.h>
#include <caml/fail.h>
#include <caml/memory.h>
#include <caml/mlvalues.h>
#include <caml/printexc.h>
#include <caml/threads.h>

#pragma GCC diagnostic ignored "-Wmissing-prototypes"

value
nbd_internal_ocaml_nbd_set_debug (value hv, value debugv)
{
  CAMLparam2 (hv, debugv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_debug");
  bool debug = Bool_val (debugv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_debug (h, debug);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_debug (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_debug");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_get_debug (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

static int
set_debug_callback_debug_fn_wrapper_locked (void *data, const char *context, const char *msg)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, contextv, msgv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  contextv = caml_copy_string (context);
  msgv = caml_copy_string (msg);
  args[0] = datav;
  args[1] = contextv;
  args[2] = msgv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }

  CAMLreturnT (int, 0);
}

static int
set_debug_callback_debug_fn_wrapper (void *data, const char *context, const char *msg)
{
  int ret;

  caml_leave_blocking_section ();
  ret = set_debug_callback_debug_fn_wrapper_locked (data, context, msg);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_set_debug_callback (value hv, value datav, value debug_fnv)
{
  CAMLparam3 (hv, datav, debug_fnv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_debug_callback");
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *debug_fn_cb = malloc (sizeof *debug_fn_cb);
  if (!debug_fn_cb) caml_raise_out_of_memory ();
  *debug_fn_cb = debug_fnv;
  caml_register_generational_global_root (debug_fn_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, debug_fn_cb);
  const void *debug_fn = set_debug_callback_debug_fn_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = debug_fn_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_debug_callback (h, data, debug_fn);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_export_name (value hv, value export_namev)
{
  CAMLparam2 (hv, export_namev);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_export_name");
  const char *export_name = String_val (export_namev);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_export_name (h, export_name);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_export_name (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_export_name");
  char *r;

  caml_enter_blocking_section ();
  r =  nbd_get_export_name (h);
  caml_leave_blocking_section ();

  if (r == NULL)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_tls (value hv, value tlsv)
{
  CAMLparam2 (hv, tlsv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_tls");
  int tls = Int_val (tlsv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_tls (h, tls);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_tls (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_tls");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_get_tls (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_int (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_tls_certificates (value hv, value dirv)
{
  CAMLparam2 (hv, dirv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_tls_certificates");
  const char *dir = String_val (dirv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_tls_certificates (h, dir);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_tls_verify_peer (value hv, value verifyv)
{
  CAMLparam2 (hv, verifyv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_tls_verify_peer");
  bool verify = Bool_val (verifyv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_tls_verify_peer (h, verify);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_tls_verify_peer (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_tls_verify_peer");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_get_tls_verify_peer (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_tls_username (value hv, value usernamev)
{
  CAMLparam2 (hv, usernamev);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_tls_username");
  const char *username = String_val (usernamev);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_tls_username (h, username);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_tls_username (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_tls_username");
  char *r;

  caml_enter_blocking_section ();
  r =  nbd_get_tls_username (h);
  caml_leave_blocking_section ();

  if (r == NULL)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_set_tls_psk_file (value hv, value filenamev)
{
  CAMLparam2 (hv, filenamev);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.set_tls_psk_file");
  const char *filename = String_val (filenamev);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_set_tls_psk_file (h, filename);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_add_meta_context (value hv, value namev)
{
  CAMLparam2 (hv, namev);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.add_meta_context");
  const char *name = String_val (namev);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_add_meta_context (h, name);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_connect_uri (value hv, value uriv)
{
  CAMLparam2 (hv, uriv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.connect_uri");
  const char *uri = String_val (uriv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_connect_uri (h, uri);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_connect_unix (value hv, value unixsocketv)
{
  CAMLparam2 (hv, unixsocketv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.connect_unix");
  const char *unixsocket = String_val (unixsocketv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_connect_unix (h, unixsocket);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_connect_tcp (value hv, value hostnamev, value portv)
{
  CAMLparam3 (hv, hostnamev, portv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.connect_tcp");
  const char *hostname = String_val (hostnamev);
  const char *port = String_val (portv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_connect_tcp (h, hostname, port);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_connect_command (value hv, value argvv)
{
  CAMLparam2 (hv, argvv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.connect_command");
  char **argv = nbd_internal_ocaml_string_list (argvv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_connect_command (h, argv);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  free (argv);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_read_only (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.read_only");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_read_only (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_flush (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_flush");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_flush (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_fua (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_fua");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_fua (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_is_rotational (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.is_rotational");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_is_rotational (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_trim (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_trim");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_trim (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_zero (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_zero");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_zero (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_df (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_df");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_df (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_multi_conn (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_multi_conn");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_multi_conn (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_cache (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_cache");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_cache (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_can_meta_context (value hv, value metacontextv)
{
  CAMLparam2 (hv, metacontextv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.can_meta_context");
  const char *metacontext = String_val (metacontextv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_can_meta_context (h, metacontext);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_size (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_size");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_get_size (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_pread (value flagsv, value hv, value bufv, value offsetv)
{
  CAMLparam4 (flagsv, hv, bufv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.pread");
  void *buf = Bytes_val (bufv);
  size_t count = caml_string_length (bufv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_pread (h, buf, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

static int
pread_structured_chunk_wrapper_locked (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, subbufv, offsetv, statusv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  subbufv = caml_alloc_string (count);
  memcpy (String_val (subbufv), subbuf, count);
  offsetv = caml_copy_int64 (offset);
  statusv = Val_int (status);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = subbufv;
  args[2] = offsetv;
  args[3] = statusv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
pread_structured_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = pread_structured_chunk_wrapper_locked (data, subbuf, count, offset, status, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_pread_structured (value flagsv, value hv, value bufv, value offsetv, value datav, value chunkv)
{
  CAMLparam5 (flagsv, hv, bufv, offsetv, datav);
  CAMLxparam1 (chunkv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.pread_structured");
  void *buf = Bytes_val (bufv);
  size_t count = caml_string_length (bufv);
  uint64_t offset = Int64_val (offsetv);
  /* This is safe because we only use this while this stack
   * frame is live.
   */
  value *data_data = &datav;
  /* This is safe because we only call this while this stack
   * frame is live.
   */
  value *chunk_cb = &chunkv;
  const void *chunk = pread_structured_chunk_wrapper;
  struct callback_data _data = { .cb = chunk_cb, .data = data_data };
  struct callback_data *data = &_data;
  int r;

  caml_enter_blocking_section ();
  r =  nbd_pread_structured (h, buf, count, offset, data, chunk, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_pread_structured_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_pread_structured (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value
nbd_internal_ocaml_nbd_pwrite (value flagsv, value hv, value bufv, value offsetv)
{
  CAMLparam4 (flagsv, hv, bufv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.pwrite");
  const void *buf = Bytes_val (bufv);
  size_t count = caml_string_length (bufv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_pwrite (h, buf, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_shutdown (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.shutdown");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_shutdown (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_flush (value flagsv, value hv)
{
  CAMLparam2 (flagsv, hv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.flush");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_flush (h, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_trim (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.trim");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_trim (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_cache (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.cache");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_cache (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_zero (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.zero");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_zero (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

static int
block_status_extent_wrapper_locked (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, metacontextv, offsetv, entriesv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  metacontextv = caml_copy_string (metacontext);
  offsetv = caml_copy_int64 (offset);
  entriesv = nbd_internal_ocaml_alloc_int32_array (entries, nr_entries);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = metacontextv;
  args[2] = offsetv;
  args[3] = entriesv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
block_status_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = block_status_extent_wrapper_locked (data, metacontext, offset, entries, nr_entries, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_block_status (value flagsv, value hv, value countv, value offsetv, value datav, value extentv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam1 (extentv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.block_status");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* This is safe because we only use this while this stack
   * frame is live.
   */
  value *data_data = &datav;
  /* This is safe because we only call this while this stack
   * frame is live.
   */
  value *extent_cb = &extentv;
  const void *extent = block_status_extent_wrapper;
  struct callback_data _data = { .cb = extent_cb, .data = data_data };
  struct callback_data *data = &_data;
  int r;

  caml_enter_blocking_section ();
  r =  nbd_block_status (h, count, offset, data, extent, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_block_status_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_block_status (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value
nbd_internal_ocaml_nbd_poll (value hv, value timeoutv)
{
  CAMLparam2 (hv, timeoutv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.poll");
  int timeout = Int_val (timeoutv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_poll (h, timeout);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_int (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_connect (value hv, value addrv)
{
  CAMLparam2 (hv, addrv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_connect");
  const struct sockaddr *addr;
  socklen_t addrlen;
  abort ();
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_connect (h, addr, addrlen);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_connect_uri (value hv, value uriv)
{
  CAMLparam2 (hv, uriv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_connect_uri");
  const char *uri = String_val (uriv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_connect_uri (h, uri);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_connect_unix (value hv, value unixsocketv)
{
  CAMLparam2 (hv, unixsocketv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_connect_unix");
  const char *unixsocket = String_val (unixsocketv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_connect_unix (h, unixsocket);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_connect_tcp (value hv, value hostnamev, value portv)
{
  CAMLparam3 (hv, hostnamev, portv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_connect_tcp");
  const char *hostname = String_val (hostnamev);
  const char *port = String_val (portv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_connect_tcp (h, hostname, port);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_connect_command (value hv, value argvv)
{
  CAMLparam2 (hv, argvv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_connect_command");
  char **argv = nbd_internal_ocaml_string_list (argvv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_connect_command (h, argv);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  free (argv);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_pread (value flagsv, value hv, value bufv, value offsetv)
{
  CAMLparam4 (flagsv, hv, bufv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pread");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pread (h, buf, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_pread_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_pread_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_pread_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_pread_notify (value flagsv, value hv, value bufv, value offsetv, value datav, value notifyv)
{
  CAMLparam5 (flagsv, hv, bufv, offsetv, datav);
  CAMLxparam1 (notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pread_notify");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_pread_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pread_notify (h, buf, count, offset, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_pread_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_pread_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

static int
aio_pread_structured_chunk_wrapper_locked (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, subbufv, offsetv, statusv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  subbufv = caml_alloc_string (count);
  memcpy (String_val (subbufv), subbuf, count);
  offsetv = caml_copy_int64 (offset);
  statusv = Val_int (status);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = subbufv;
  args[2] = offsetv;
  args[3] = statusv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_pread_structured_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_pread_structured_chunk_wrapper_locked (data, subbuf, count, offset, status, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_pread_structured (value flagsv, value hv, value bufv, value offsetv, value datav, value chunkv)
{
  CAMLparam5 (flagsv, hv, bufv, offsetv, datav);
  CAMLxparam1 (chunkv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pread_structured");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *chunk_cb = malloc (sizeof *chunk_cb);
  if (!chunk_cb) caml_raise_out_of_memory ();
  *chunk_cb = chunkv;
  caml_register_generational_global_root (chunk_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, chunk_cb);
  const void *chunk = aio_pread_structured_chunk_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = chunk_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pread_structured (h, buf, count, offset, data, chunk, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_pread_structured_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_pread_structured (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

static int
aio_pread_structured_notify_chunk_wrapper_locked (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, subbufv, offsetv, statusv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  subbufv = caml_alloc_string (count);
  memcpy (String_val (subbufv), subbuf, count);
  offsetv = caml_copy_int64 (offset);
  statusv = Val_int (status);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = subbufv;
  args[2] = offsetv;
  args[3] = statusv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_pread_structured_notify_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_pread_structured_notify_chunk_wrapper_locked (data, subbuf, count, offset, status, error);
  caml_enter_blocking_section ();
  return ret;
}
static int
aio_pread_structured_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_pread_structured_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_pread_structured_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_pread_structured_notify (value flagsv, value hv, value bufv, value offsetv, value datav, value chunkv, value notifyv)
{
  CAMLparam5 (flagsv, hv, bufv, offsetv, datav);
  CAMLxparam2 (chunkv, notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pread_structured_notify");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *chunk_cb = malloc (sizeof *chunk_cb);
  if (!chunk_cb) caml_raise_out_of_memory ();
  *chunk_cb = chunkv;
  caml_register_generational_global_root (chunk_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, chunk_cb);
  const void *chunk = aio_pread_structured_notify_chunk_wrapper;
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_pread_structured_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = chunk_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pread_structured_notify (h, buf, count, offset, data, chunk, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_pread_structured_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_pread_structured_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value
nbd_internal_ocaml_nbd_aio_pwrite (value flagsv, value hv, value bufv, value offsetv)
{
  CAMLparam4 (flagsv, hv, bufv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pwrite");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  const void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pwrite (h, buf, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_pwrite_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_pwrite_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_pwrite_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_pwrite_notify (value flagsv, value hv, value bufv, value offsetv, value datav, value notifyv)
{
  CAMLparam5 (flagsv, hv, bufv, offsetv, datav);
  CAMLxparam1 (notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_pwrite_notify");
  struct nbd_buffer buf_buf = NBD_buffer_val (bufv);
  const void *buf = buf_buf.data;
  size_t count = buf_buf.len;
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_pwrite_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_pwrite_notify (h, buf, count, offset, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_pwrite_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_pwrite_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value
nbd_internal_ocaml_nbd_aio_disconnect (value flagsv, value hv)
{
  CAMLparam2 (flagsv, hv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_disconnect");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_disconnect (h, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_flush (value flagsv, value hv)
{
  CAMLparam2 (flagsv, hv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_flush");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_flush (h, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_flush_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_flush_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_flush_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_flush_notify (value flagsv, value hv, value datav, value notifyv)
{
  CAMLparam4 (flagsv, hv, datav, notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_flush_notify");
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_flush_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_flush_notify (h, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_trim (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_trim");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_trim (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_trim_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_trim_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_trim_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_trim_notify (value flagsv, value hv, value countv, value offsetv, value datav, value notifyv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam1 (notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_trim_notify");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_trim_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_trim_notify (h, count, offset, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_trim_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_trim_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value
nbd_internal_ocaml_nbd_aio_cache (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_cache");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_cache (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_cache_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_cache_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_cache_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_cache_notify (value flagsv, value hv, value countv, value offsetv, value datav, value notifyv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam1 (notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_cache_notify");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_cache_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_cache_notify (h, count, offset, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_cache_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_cache_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value
nbd_internal_ocaml_nbd_aio_zero (value flagsv, value hv, value countv, value offsetv)
{
  CAMLparam4 (flagsv, hv, countv, offsetv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_zero");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_zero (h, count, offset, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

static int
aio_zero_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_zero_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_zero_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_zero_notify (value flagsv, value hv, value countv, value offsetv, value datav, value notifyv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam1 (notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_zero_notify");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_zero_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = notify_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_zero_notify (h, count, offset, data, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_zero_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_zero_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

static int
aio_block_status_extent_wrapper_locked (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, metacontextv, offsetv, entriesv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  metacontextv = caml_copy_string (metacontext);
  offsetv = caml_copy_int64 (offset);
  entriesv = nbd_internal_ocaml_alloc_int32_array (entries, nr_entries);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = metacontextv;
  args[2] = offsetv;
  args[3] = entriesv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_block_status_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_block_status_extent_wrapper_locked (data, metacontext, offset, entries, nr_entries, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_block_status (value flagsv, value hv, value countv, value offsetv, value datav, value extentv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam1 (extentv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_block_status");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *extent_cb = malloc (sizeof *extent_cb);
  if (!extent_cb) caml_raise_out_of_memory ();
  *extent_cb = extentv;
  caml_register_generational_global_root (extent_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, extent_cb);
  const void *extent = aio_block_status_extent_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = extent_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_block_status (h, count, offset, data, extent, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_block_status_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_block_status (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

static int
aio_block_status_notify_extent_wrapper_locked (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  CAMLparam0 ();
  CAMLlocal5 (datav, metacontextv, offsetv, entriesv, errorv);
  CAMLlocal2 (fnv, rv);
  value args[5];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  metacontextv = caml_copy_string (metacontext);
  offsetv = caml_copy_int64 (offset);
  entriesv = nbd_internal_ocaml_alloc_int32_array (entries, nr_entries);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = metacontextv;
  args[2] = offsetv;
  args[3] = entriesv;
  args[4] = errorv;
  rv = caml_callbackN_exn (fnv, 5, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_block_status_notify_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_block_status_notify_extent_wrapper_locked (data, metacontext, offset, entries, nr_entries, error);
  caml_enter_blocking_section ();
  return ret;
}
static int
aio_block_status_notify_notify_wrapper_locked (void *data, int64_t handle, int *error)
{
  CAMLparam0 ();
  CAMLlocal3 (datav, handlev, errorv);
  CAMLlocal2 (fnv, rv);
  value args[3];

  const struct callback_data *_data = data;
  fnv = *_data->cb;
  datav = *_data->data;
  handlev = caml_copy_int64 (handle);
  errorv = caml_alloc_tuple (1);
  Store_field (errorv, 0, Val_int (*error));
  args[0] = datav;
  args[1] = handlev;
  args[2] = errorv;
  rv = caml_callbackN_exn (fnv, 3, args);
  if (Is_exception_result (rv)) {
    /* XXX This is not really an error as callbacks can return
     * an error indication.  But perhaps we should direct this
     * to a more suitable place or formalize what exception
     * means error versus unexpected failure.
     */
    fprintf (stderr,
             "libnbd: uncaught OCaml exception: %s",
             caml_format_exception (Extract_exception (rv)));
    CAMLreturnT (int, -1);
  }
  *error = Int_val (Field (errorv, 0));

  CAMLreturnT (int, 0);
}

static int
aio_block_status_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;

  caml_leave_blocking_section ();
  ret = aio_block_status_notify_notify_wrapper_locked (data, handle, error);
  caml_enter_blocking_section ();
  return ret;
}
value
nbd_internal_ocaml_nbd_aio_block_status_notify (value flagsv, value hv, value countv, value offsetv, value datav, value extentv, value notifyv)
{
  CAMLparam5 (flagsv, hv, countv, offsetv, datav);
  CAMLxparam2 (extentv, notifyv);
  CAMLlocal1 (rv);

  uint32_t flags = Flags_val (flagsv);
  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_block_status_notify");
  uint64_t count = Int64_val (countv);
  uint64_t offset = Int64_val (offsetv);
  /* The function may save a reference to this value, so we
   * must treat it as a possible GC root.
   */
  value *data_data = malloc (sizeof *data_data);
  if (!data_data) caml_raise_out_of_memory ();
  *data_data = datav;
  caml_register_generational_global_root (data_data);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, data_data);
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *extent_cb = malloc (sizeof *extent_cb);
  if (!extent_cb) caml_raise_out_of_memory ();
  *extent_cb = extentv;
  caml_register_generational_global_root (extent_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, extent_cb);
  const void *extent = aio_block_status_notify_extent_wrapper;
  /* The function may save a reference to this closure, so we
   * must treat it as a possible GC root.
   */
  value *notify_cb = malloc (sizeof *notify_cb);
  if (!notify_cb) caml_raise_out_of_memory ();
  *notify_cb = notifyv;
  caml_register_generational_global_root (notify_cb);
  nbd_add_close_callback (h, nbd_internal_ocaml_free_root, notify_cb);
  const void *notify = aio_block_status_notify_notify_wrapper;
  struct callback_data *data = malloc (sizeof *data);
  if (!data) caml_raise_out_of_memory ();
  data->cb = extent_cb;
  data->data = data_data;
  nbd_add_close_callback (h, free, data_data);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_block_status_notify (h, count, offset, data, extent, notify, flags);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

/* Byte-code compat function because this method has > 5 parameters.
 */
value
nbd_internal_ocaml_nbd_aio_block_status_notify_byte (value *argv, int argn)
{
  return nbd_internal_ocaml_nbd_aio_block_status_notify (argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value
nbd_internal_ocaml_nbd_aio_get_fd (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_get_fd");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_get_fd (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_int (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_get_direction (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_get_direction");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_get_direction (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_int (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_notify_read (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_notify_read");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_notify_read (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_notify_write (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_notify_write");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_notify_write (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_unit;
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_created (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_created");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_created (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_connecting (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_connecting");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_connecting (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_ready (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_ready");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_ready (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_processing (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_processing");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_processing (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_dead (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_dead");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_dead (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_is_closed (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_is_closed");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_is_closed (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_command_completed (value hv, value handlev)
{
  CAMLparam2 (hv, handlev);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_command_completed");
  int64_t handle = Int64_val (handlev);
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_command_completed (h, handle);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_peek_command_completed (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_peek_command_completed");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_peek_command_completed (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_aio_in_flight (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.aio_in_flight");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_aio_in_flight (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_int (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_connection_state (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.connection_state");
  const char *r;

  caml_enter_blocking_section ();
  r =  nbd_connection_state (h);
  caml_leave_blocking_section ();

  if (r == NULL)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_string (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_package_name (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_package_name");
  const char *r;

  caml_enter_blocking_section ();
  r =  nbd_get_package_name (h);
  caml_leave_blocking_section ();

  if (r == NULL)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_string (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_get_version (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.get_version");
  const char *r;

  caml_enter_blocking_section ();
  r =  nbd_get_version (h);
  caml_leave_blocking_section ();

  if (r == NULL)
    nbd_internal_ocaml_raise_error ();

  rv = caml_copy_string (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_supports_tls (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.supports_tls");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_supports_tls (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

value
nbd_internal_ocaml_nbd_supports_uri (value hv)
{
  CAMLparam1 (hv);
  CAMLlocal1 (rv);

  struct nbd_handle *h = NBD_val (hv);
  if (h == NULL)
    nbd_internal_ocaml_raise_closed ("NBD.supports_uri");
  int r;

  caml_enter_blocking_section ();
  r =  nbd_supports_uri (h);
  caml_leave_blocking_section ();

  if (r == -1)
    nbd_internal_ocaml_raise_error ();

  rv = Val_bool (r);
  CAMLreturn (rv);
}

