/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#define PY_SSIZE_T_CLEAN 1
#include <Python.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

#include <libnbd.h>

#include <methods.h>

PyObject *
nbd_internal_py_set_debug (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  int debug;

  if (!PyArg_ParseTuple (args, (char *) "O" "b"
                         ":nbd_set_debug",
                         &py_h, &debug))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_set_debug (h, debug);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_debug (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_debug",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_debug (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

struct set_debug_callback_debug_fn_data {
  PyObject *fn;
  PyObject *data;
};

static int
set_debug_callback_debug_fn_wrapper (void *data, const char *context, const char *msg)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct set_debug_callback_debug_fn_data *_data = data;

  py_args = Py_BuildValue ("(" "O" "s" "s" ")", _data->data, context, msg);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  return ret;
}

PyObject *
nbd_internal_py_set_debug_callback (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  struct set_debug_callback_debug_fn_data *debug_fn_data;

  debug_fn_data = malloc (sizeof *debug_fn_data);
  if (debug_fn_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "O"
                         ":nbd_set_debug_callback",
                         &py_h, &debug_fn_data->data, &debug_fn_data->fn))
    return NULL;
  h = get_handle (py_h);
  if (!PyCallable_Check (debug_fn_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter debug_fn is not callable");
    return NULL;
  }
  ret = nbd_set_debug_callback (h, debug_fn_data, set_debug_callback_debug_fn_wrapper);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, debug_fn_data);
  return py_ret;
}

PyObject *
nbd_internal_py_set_export_name (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *export_name;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_set_export_name",
                         &py_h, &export_name))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_set_export_name (h, export_name);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_export_name (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  char *ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_export_name",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_export_name (h);
  if (ret == NULL) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyUnicode_FromString (ret);
  free (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_set_tls (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  int tls;

  if (!PyArg_ParseTuple (args, (char *) "O" "i"
                         ":nbd_set_tls",
                         &py_h, &tls))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_set_tls (h, tls);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_tls (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_tls",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_tls (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_set_tls_certificates (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_dir = NULL;
  char *dir = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O&"
                         ":nbd_set_tls_certificates",
                         &py_h, PyUnicode_FSConverter, &py_dir))
    return NULL;
  h = get_handle (py_h);
  dir = PyBytes_AS_STRING (py_dir);
  assert (dir != NULL);
  ret = nbd_set_tls_certificates (h, dir);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  Py_XDECREF (py_dir);
  return py_ret;
}

PyObject *
nbd_internal_py_set_tls_verify_peer (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  int verify;

  if (!PyArg_ParseTuple (args, (char *) "O" "b"
                         ":nbd_set_tls_verify_peer",
                         &py_h, &verify))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_set_tls_verify_peer (h, verify);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_tls_verify_peer (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_tls_verify_peer",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_tls_verify_peer (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_set_tls_username (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *username;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_set_tls_username",
                         &py_h, &username))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_set_tls_username (h, username);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_tls_username (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  char *ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_tls_username",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_tls_username (h);
  if (ret == NULL) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyUnicode_FromString (ret);
  free (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_set_tls_psk_file (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_filename = NULL;
  char *filename = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O&"
                         ":nbd_set_tls_psk_file",
                         &py_h, PyUnicode_FSConverter, &py_filename))
    return NULL;
  h = get_handle (py_h);
  filename = PyBytes_AS_STRING (py_filename);
  assert (filename != NULL);
  ret = nbd_set_tls_psk_file (h, filename);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  Py_XDECREF (py_filename);
  return py_ret;
}

PyObject *
nbd_internal_py_add_meta_context (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *name;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_add_meta_context",
                         &py_h, &name))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_add_meta_context (h, name);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_connect_uri (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *uri;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_connect_uri",
                         &py_h, &uri))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_connect_uri (h, uri);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_connect_unix (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_unixsocket = NULL;
  char *unixsocket = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O&"
                         ":nbd_connect_unix",
                         &py_h, PyUnicode_FSConverter, &py_unixsocket))
    return NULL;
  h = get_handle (py_h);
  unixsocket = PyBytes_AS_STRING (py_unixsocket);
  assert (unixsocket != NULL);
  ret = nbd_connect_unix (h, unixsocket);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  Py_XDECREF (py_unixsocket);
  return py_ret;
}

PyObject *
nbd_internal_py_connect_tcp (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *hostname;
  const char *port;

  if (!PyArg_ParseTuple (args, (char *) "O" "s" "s"
                         ":nbd_connect_tcp",
                         &py_h, &hostname, &port))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_connect_tcp (h, hostname, port);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_connect_command (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_argv;
  char **argv = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O"
                         ":nbd_connect_command",
                         &py_h, &py_argv))
    return NULL;
  h = get_handle (py_h);
  argv = nbd_internal_py_get_string_list (py_argv);
  if (!argv) { py_ret = NULL; goto out; }
  ret = nbd_connect_command (h, argv);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  nbd_internal_py_free_string_list (argv);
  return py_ret;
}

PyObject *
nbd_internal_py_read_only (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_read_only",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_read_only (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_flush (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_flush",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_flush (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_fua (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_fua",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_fua (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_is_rotational (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_is_rotational",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_is_rotational (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_trim (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_trim",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_trim (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_zero (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_zero",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_zero (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_df (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_df",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_df (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_multi_conn (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_multi_conn",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_multi_conn (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_cache (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_can_cache",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_cache (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_can_meta_context (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *metacontext;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_can_meta_context",
                         &py_h, &metacontext))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_can_meta_context (h, metacontext);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_size (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_size",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_size (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_pread (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  char *buf;
  Py_ssize_t count;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "n" "K" "I"
                         ":nbd_pread",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  buf = malloc (count);
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_pread (h, buf, count, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyBytes_FromStringAndSize (buf, count);

 out:
  return py_ret;
}

struct pread_structured_chunk_data {
  PyObject *fn;
  PyObject *data;
};

static int
pread_structured_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct pread_structured_chunk_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "y#" "K" "i" "O" ")", _data->data, subbuf, (int) count, offset, status, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_pread_structured (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  char *buf;
  Py_ssize_t count;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct pread_structured_chunk_data _chunk_data, *chunk_data = &_chunk_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "n" "K" "O" "O" "I"
                         ":nbd_pread_structured",
                         &py_h, &count, &offset, &chunk_data->data, &chunk_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  buf = malloc (count);
  offset_u64 = offset;
  if (!PyCallable_Check (chunk_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter chunk is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_pread_structured (h, buf, count, offset_u64, chunk_data, pread_structured_chunk_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyBytes_FromStringAndSize (buf, count);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_pwrite (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  Py_buffer buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "y*" "K" "I"
                         ":nbd_pwrite",
                         &py_h, &buf, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_pwrite (h, buf.buf, buf.len, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  PyBuffer_Release (&buf);
  return py_ret;
}

PyObject *
nbd_internal_py_shutdown (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_shutdown",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_shutdown (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_flush (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "I"
                         ":nbd_flush",
                         &py_h, &flags))
    return NULL;
  h = get_handle (py_h);
  flags_u32 = flags;
  ret = nbd_flush (h, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_trim (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_trim",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_trim (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_cache (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_cache",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_cache (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_zero (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_zero",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_zero (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

struct block_status_extent_data {
  PyObject *fn;
  PyObject *data;
};

static int
block_status_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct block_status_extent_data *_data = data;
  PyObject *py_entries = PyList_New (nr_entries);
  for (size_t i = 0; i < nr_entries; ++i)
    PyList_SET_ITEM (py_entries, i, PyLong_FromUnsignedLong (entries[i]));
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "s" "K" "O" "O" ")", _data->data, metacontext, offset, py_entries, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  Py_DECREF (py_entries);
  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_block_status (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct block_status_extent_data _extent_data, *extent_data = &_extent_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "I"
                         ":nbd_block_status",
                         &py_h, &count, &offset, &extent_data->data, &extent_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (extent_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter extent is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_block_status (h, count_u64, offset_u64, extent_data, block_status_extent_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_poll (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  int timeout;

  if (!PyArg_ParseTuple (args, (char *) "O" "i"
                         ":nbd_poll",
                         &py_h, &timeout))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_poll (h, timeout);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_connect (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  /* XXX Complicated - Python uses a tuple of different
   * lengths for the different socket types.
   */
  PyObject *addr;

  if (!PyArg_ParseTuple (args, (char *) "O" "O"
                         ":nbd_aio_connect",
                         &py_h, &addr))
    return NULL;
  h = get_handle (py_h);
  abort (); /* XXX SockAddrAndLen not implemented */
  ret = nbd_aio_connect (h, /* XXX */ (void *) addr, 0);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_connect_uri (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *uri;

  if (!PyArg_ParseTuple (args, (char *) "O" "s"
                         ":nbd_aio_connect_uri",
                         &py_h, &uri))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_connect_uri (h, uri);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_connect_unix (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_unixsocket = NULL;
  char *unixsocket = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O&"
                         ":nbd_aio_connect_unix",
                         &py_h, PyUnicode_FSConverter, &py_unixsocket))
    return NULL;
  h = get_handle (py_h);
  unixsocket = PyBytes_AS_STRING (py_unixsocket);
  assert (unixsocket != NULL);
  ret = nbd_aio_connect_unix (h, unixsocket);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  Py_XDECREF (py_unixsocket);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_connect_tcp (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  const char *hostname;
  const char *port;

  if (!PyArg_ParseTuple (args, (char *) "O" "s" "s"
                         ":nbd_aio_connect_tcp",
                         &py_h, &hostname, &port))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_connect_tcp (h, hostname, port);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_connect_command (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  PyObject *py_argv;
  char **argv = NULL;

  if (!PyArg_ParseTuple (args, (char *) "O" "O"
                         ":nbd_aio_connect_command",
                         &py_h, &py_argv))
    return NULL;
  h = get_handle (py_h);
  argv = nbd_internal_py_get_string_list (py_argv);
  if (!argv) { py_ret = NULL; goto out; }
  ret = nbd_aio_connect_command (h, argv);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  nbd_internal_py_free_string_list (argv);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_pread (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "I"
                         ":nbd_aio_pread",
                         &py_h, &buf, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_aio_pread (h, buf_buf->data, buf_buf->len, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_pread_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_pread_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_pread_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_pread_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_pread_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "O" "O" "I"
                         ":nbd_aio_pread_notify",
                         &py_h, &buf, &offset, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_pread_notify (h, buf_buf->data, buf_buf->len, offset_u64, notify_data, aio_pread_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

struct aio_pread_structured_chunk_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_pread_structured_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_pread_structured_chunk_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "y#" "K" "i" "O" ")", _data->data, subbuf, (int) count, offset, status, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_pread_structured (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_pread_structured_chunk_data *chunk_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  chunk_data = malloc (sizeof *chunk_data);
  if (chunk_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "O" "O" "I"
                         ":nbd_aio_pread_structured",
                         &py_h, &buf, &offset, &chunk_data->data, &chunk_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  if (!PyCallable_Check (chunk_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter chunk is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_pread_structured (h, buf_buf->data, buf_buf->len, offset_u64, chunk_data, aio_pread_structured_chunk_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, chunk_data);
  return py_ret;
}

struct aio_pread_structured_notify_chunk_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_pread_structured_notify_chunk_wrapper (void *data, const void *subbuf, size_t count, uint64_t offset, int status, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_pread_structured_notify_chunk_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "y#" "K" "i" "O" ")", _data->data, subbuf, (int) count, offset, status, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

struct aio_pread_structured_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_pread_structured_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_pread_structured_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_pread_structured_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_pread_structured_notify_chunk_data *chunk_data;
  struct aio_pread_structured_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  chunk_data = malloc (sizeof *chunk_data);
  if (chunk_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "O" "O" "O" "I"
                         ":nbd_aio_pread_structured_notify",
                         &py_h, &buf, &offset, &chunk_data->data, &chunk_data->fn, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  if (!PyCallable_Check (chunk_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter chunk is not callable");
    return NULL;
  }
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_pread_structured_notify (h, buf_buf->data, buf_buf->len, offset_u64, chunk_data, aio_pread_structured_notify_chunk_wrapper, aio_pread_structured_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, chunk_data);
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_pwrite (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "I"
                         ":nbd_aio_pwrite",
                         &py_h, &buf, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_aio_pwrite (h, buf_buf->data, buf_buf->len, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_pwrite_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_pwrite_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_pwrite_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_pwrite_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  PyObject *buf; /* PyCapsule pointing to struct py_aio_buffer */
  struct py_aio_buffer *buf_buf;
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_pwrite_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "K" "O" "O" "I"
                         ":nbd_aio_pwrite_notify",
                         &py_h, &buf, &offset, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  buf_buf = nbd_internal_py_get_aio_buffer (buf);
  offset_u64 = offset;
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_pwrite_notify (h, buf_buf->data, buf_buf->len, offset_u64, notify_data, aio_pwrite_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_disconnect (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "I"
                         ":nbd_aio_disconnect",
                         &py_h, &flags))
    return NULL;
  h = get_handle (py_h);
  flags_u32 = flags;
  ret = nbd_aio_disconnect (h, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_flush (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "I"
                         ":nbd_aio_flush",
                         &py_h, &flags))
    return NULL;
  h = get_handle (py_h);
  flags_u32 = flags;
  ret = nbd_aio_flush (h, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_flush_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_flush_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_flush_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_flush_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  struct aio_flush_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "O" "O" "I"
                         ":nbd_aio_flush_notify",
                         &py_h, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_flush_notify (h, notify_data, aio_flush_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_trim (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_aio_trim",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_aio_trim (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_trim_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_trim_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_trim_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_trim_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_trim_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "I"
                         ":nbd_aio_trim_notify",
                         &py_h, &count, &offset, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_trim_notify (h, count_u64, offset_u64, notify_data, aio_trim_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_cache (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_aio_cache",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_aio_cache (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_cache_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_cache_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_cache_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_cache_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_cache_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "I"
                         ":nbd_aio_cache_notify",
                         &py_h, &count, &offset, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_cache_notify (h, count_u64, offset_u64, notify_data, aio_cache_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_zero (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "I"
                         ":nbd_aio_zero",
                         &py_h, &count, &offset, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  flags_u32 = flags;
  ret = nbd_aio_zero (h, count_u64, offset_u64, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

struct aio_zero_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_zero_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_zero_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_zero_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_zero_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "I"
                         ":nbd_aio_zero_notify",
                         &py_h, &count, &offset, &notify_data->data, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_zero_notify (h, count_u64, offset_u64, notify_data, aio_zero_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

struct aio_block_status_extent_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_block_status_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_block_status_extent_data *_data = data;
  PyObject *py_entries = PyList_New (nr_entries);
  for (size_t i = 0; i < nr_entries; ++i)
    PyList_SET_ITEM (py_entries, i, PyLong_FromUnsignedLong (entries[i]));
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "s" "K" "O" "O" ")", _data->data, metacontext, offset, py_entries, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  Py_DECREF (py_entries);
  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_block_status (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_block_status_extent_data *extent_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  extent_data = malloc (sizeof *extent_data);
  if (extent_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "I"
                         ":nbd_aio_block_status",
                         &py_h, &count, &offset, &extent_data->data, &extent_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (extent_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter extent is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_block_status (h, count_u64, offset_u64, extent_data, aio_block_status_extent_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, extent_data);
  return py_ret;
}

struct aio_block_status_notify_extent_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_block_status_notify_extent_wrapper (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_block_status_notify_extent_data *_data = data;
  PyObject *py_entries = PyList_New (nr_entries);
  for (size_t i = 0; i < nr_entries; ++i)
    PyList_SET_ITEM (py_entries, i, PyLong_FromUnsignedLong (entries[i]));
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "s" "K" "O" "O" ")", _data->data, metacontext, offset, py_entries, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  Py_DECREF (py_entries);
  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

struct aio_block_status_notify_notify_data {
  PyObject *fn;
  PyObject *data;
};

static int
aio_block_status_notify_notify_wrapper (void *data, int64_t handle, int *error)
{
  int ret;
  PyGILState_STATE py_save = PyGILState_UNLOCKED;
  PyObject *py_args, *py_ret;
  struct aio_block_status_notify_notify_data *_data = data;
  PyObject *py_error_modname = PyUnicode_FromString ("ctypes");
  if (!py_error_modname) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error_mod = PyImport_Import (py_error_modname);
  Py_DECREF (py_error_modname);
  if (!py_error_mod) { PyErr_PrintEx (0); return -1; }
  PyObject *py_error = PyObject_CallMethod (py_error_mod, "c_int", "i", *error);
  if (!py_error) { PyErr_PrintEx (0); return -1; }

  py_args = Py_BuildValue ("(" "O" "L" "O" ")", _data->data, handle, py_error);
  Py_INCREF (py_args);

  if (PyEval_ThreadsInitialized ())
    py_save = PyGILState_Ensure ();

  py_ret = PyObject_CallObject (_data->fn, py_args);

  if (PyEval_ThreadsInitialized ())
    PyGILState_Release (py_save);

  Py_DECREF (py_args);

  if (py_ret != NULL) {
    ret = 0;
    Py_DECREF (py_ret); /* return value is discarded */
  }
  else {
    ret = -1;
    PyErr_PrintEx (0); /* print exception */
  };

  PyObject *py_error_ret = PyObject_GetAttrString (py_error, "value");
  *error = PyLong_AsLong (py_error_ret);
  Py_DECREF (py_error_ret);
  Py_DECREF (py_error);
  return ret;
}

PyObject *
nbd_internal_py_aio_block_status_notify (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;
  uint64_t count_u64;
  unsigned long long count; /* really uint64_t */
  uint64_t offset_u64;
  unsigned long long offset; /* really uint64_t */
  struct aio_block_status_notify_extent_data *extent_data;
  struct aio_block_status_notify_notify_data *notify_data;
  uint32_t flags_u32;
  unsigned int flags; /* really uint32_t */

  extent_data = malloc (sizeof *extent_data);
  if (extent_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  notify_data = malloc (sizeof *notify_data);
  if (notify_data == NULL) {
    PyErr_NoMemory ();
    return NULL;
  }
  if (!PyArg_ParseTuple (args, (char *) "O" "K" "K" "O" "O" "O" "I"
                         ":nbd_aio_block_status_notify",
                         &py_h, &count, &offset, &extent_data->data, &extent_data->fn, &notify_data->fn, &flags))
    return NULL;
  h = get_handle (py_h);
  count_u64 = count;
  offset_u64 = offset;
  if (!PyCallable_Check (extent_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter extent is not callable");
    return NULL;
  }
  if (!PyCallable_Check (notify_data->fn)) {
    PyErr_SetString (PyExc_TypeError,
                     "callback parameter notify is not callable");
    return NULL;
  }
  flags_u32 = flags;
  ret = nbd_aio_block_status_notify (h, count_u64, offset_u64, extent_data, aio_block_status_notify_extent_wrapper, aio_block_status_notify_notify_wrapper, flags_u32);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, extent_data);
  /* This ensures the callback data is freed eventually. */
  nbd_add_close_callback (h, free, notify_data);
  return py_ret;
}

PyObject *
nbd_internal_py_aio_get_fd (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_get_fd",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_get_fd (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_get_direction (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_get_direction",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_get_direction (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_notify_read (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_notify_read",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_notify_read (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_notify_write (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_notify_write",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_notify_write (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = Py_None;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_created (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_created",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_created (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_connecting (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_connecting",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_connecting (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_ready (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_ready",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_ready (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_processing (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_processing",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_processing (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_dead (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_dead",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_dead (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_is_closed (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_is_closed",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_is_closed (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_command_completed (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;
  int64_t handle_i64;
  long long handle; /* really int64_t */

  if (!PyArg_ParseTuple (args, (char *) "O" "L"
                         ":nbd_aio_command_completed",
                         &py_h, &handle))
    return NULL;
  h = get_handle (py_h);
  handle_i64 = handle;
  ret = nbd_aio_command_completed (h, handle_i64);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_peek_command_completed (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int64_t ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_peek_command_completed",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_peek_command_completed (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLongLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_aio_in_flight (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_aio_in_flight",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_aio_in_flight (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyLong_FromLong (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_connection_state (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  const char *ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_connection_state",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_connection_state (h);
  if (ret == NULL) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyUnicode_FromString (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_package_name (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  const char *ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_package_name",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_package_name (h);
  if (ret == NULL) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyUnicode_FromString (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_get_version (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  const char *ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_get_version",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_get_version (h);
  if (ret == NULL) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = PyUnicode_FromString (ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_supports_tls (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_supports_tls",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_supports_tls (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

PyObject *
nbd_internal_py_supports_uri (PyObject *self, PyObject *args)
{
  PyObject *py_h;
  struct nbd_handle *h;
  int ret;
  PyObject *py_ret;

  if (!PyArg_ParseTuple (args, (char *) "O"
                         ":nbd_supports_uri",
                         &py_h))
    return NULL;
  h = get_handle (py_h);
  ret = nbd_supports_uri (h);
  if (ret == -1) {
    raise_exception ();
    py_ret = NULL;
    goto out;
  }
  py_ret = ret ? Py_True : Py_False;
  Py_INCREF (py_ret);

 out:
  return py_ret;
}

